/*
Copyright (c) 2005-2009 TeamF1, Inc.
All rights reserved.
*/
/* wan_advanced.htm */

function wanAdvValidate ()
    {
    /* L10N Error Message Collection Start */
    var mtuErrMsg = "Invalid MTU size: Please enter a valid MTU size";
    var errMsgObjL10N = document.getElementById('hdMtuSizeErr');
    if (errMsgObjL10N) mtuErrMsg = errMsgObjL10N.value;
    var macAddrErrMsg = "Invalid MAC address: Please enter a value in the form XX:XX:XX:XX:XX:XX";
    errMsgObjL10N = document.getElementById('hdMacAddrErr');
    if (errMsgObjL10N) macAddrErrMsg = errMsgObjL10N.value;
    var testPeriodErr = "Invalid test period";
    errMsgObjL10N = document.getElementById('hdTestPeriodErr');
    if (errMsgObjL10N) testPeriodErr = errMsgObjL10N.value;
    var failoverErr = "Invalid failover tries"
    errMsgObjL10N = document.getElementById('hdFailoverErr');
    if (errMsgObjL10N) failoverErr = errMsgObjL10N.value;
    var uploadErr = "Please enter WAN connection speed upload"
    errMsgObjL10N = document.getElementById('hdUploadErr');
    if (errMsgObjL10N) uploadErr = errMsgObjL10N.value;
    var downloadErr = "Please enter WAN connection speed download";
    errMsgObjL10N = document.getElementById('hdDownloadErr');
    if (errMsgObjL10N) downloadErr = errMsgObjL10N.value;
    var forOctet = "for octet "
    errMsgObjL10N = document.getElementById('hdForOctet');
    if (errMsgObjL10N) forOctet = errMsgObjL10N.value + " ";
    var invalidDNSSvrErr = "Invalid DNS server IP address."
    errMsgObjL10N = document.getElementById('hdInvalidDNSSvrErr');
    if (errMsgObjL10N) invalidDNSSvrErr = errMsgObjL10N.value + ".";
    var invalidIpAddrErr = "Invalid IP address."
    errMsgObjL10N = document.getElementById('hdInvalidIpAddrErr');
    if (errMsgObjL10N) invalidIpAddrErr = errMsgObjL10N.value + " ";
    var invalidMacErr = "Invalid MAC address:";
    errMsgObjL10N = document.getElementById('hdInvalidMacErr');
    if (errMsgObjL10N) invalidMacErr = errMsgObjL10N.value + ": ";
    var invalidTestPeriodErr = "Invalid test period: ";
    errMsgObjL10N = document.getElementById('hdInvalidTestPeriodErr');
    if (errMsgObjL10N) invalidTestPeriodErr = errMsgObjL10N.value + ": ";
    var invalidFailureRetriesErr = "Invalid failover tries: ";
    errMsgObjL10N = document.getElementById('hdInvalidFailRetriesErr');
    if (errMsgObjL10N) invalidFailureRetriesErr = errMsgObjL10N.value + ": ";
    var seconds = "Seconds";
    errMsgObjL10N = document.getElementById('hdSeconds');
    if (errMsgObjL10N) seconds = errMsgObjL10N.value;
    /* L10N Error Message Collection End */

    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtMTUSizeDefault," + mtuErrMsg;
    txtFieldIdArr[1] = "txtRouterMACAddr," + macAddrErrMsg;
    txtFieldIdArr[2] = "txtPeriod," + testPeriodErr;
    txtFieldIdArr[3] = "txtFailover," + failoverErr;
    txtFieldIdArr[4] = "txt1Custom," + uploadErr;
    txtFieldIdArr[5] = "txt2Custom," + downloadErr;

    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;

	var macObj = document.getElementById('txtRouterMACAddr');
    if (macObj.disabled) {}
    else if (!(macAddrValidate (macObj.value, true, invalidMacErr, '')))
        {
        macObj.focus ();
        return false;
        }

	if (ipv4AddrOctetsValidate ('tblDnsServer', 'IP', false, true, invalidDNSSvrErr, forOctet, true) == false)
		return false;
		
	if (ipv4AddrOctetsValidate ('tblIpAddr', 'IP', false, true, invalidIpAddrErr, forOctet, true) == false)
		return false;
        
    var myObj = document.getElementById('txtPeriod');
    if (!myObj || myObj.disabled) {}
    else if (numericValueRangeCheck (myObj, 1, invalidTestPeriodErr, 30, 999, true, invalidTestPeriodErr, seconds) == false)
         return false;

    myObj = document.getElementById('txtFailover');
    if (!myObj || myObj.disabled) {}
    else if (numericValueRangeCheck (myObj, 1, invalidFailureRetriesErr, 2, 999, true, invalidFailureRetriesErr, '') == false)
         return false;
    if (mtuSizeValid() == false)
    	return false;

    return true;
    }
function mtuSizeValid()
	{
    /* L10N Error Message Collection Start */
    var invalidMTUErr = "Invalid MTU Size: ";
    errMsgObjL10N = document.getElementById('hdInvalidMTUErr');
    if (errMsgObjL10N) invalidMTUErr = errMsgObjL10N.value + ": ";
    /* L10N Error Message Collection End */

	var loginReqd = document.getElementById("hdLoginReqd").value;
	var maxMtu = 1500;
	if(loginReqd == "1")
		maxMtu = 1492;
	var myObj = document.getElementById('txtMTUSizeDefault');
    if (!myObj || myObj.disabled) {}
    else if (numericValueRangeCheck (myObj, 1, invalidMTUErr, 1, maxMtu, true, invalidMTUErr, '') == false)
         return false;
    return true;
	}
function wanAdvancedInit ()
	{
	MTUSizeCheck ();
	routerMACAddrCheck ();
	detectMethodCheck ();
	checkCustom ('upload','txt1Custom');
	checkCustom ('download','txt2Custom');
	checkFailOver ()
	}
function checkCustom(speed,txtCustom)
    {
     var val=comboSelectedValueGet(speed);
     if(parseInt (val, 10) == 12)
       fieldStateChangeWr ('','',txtCustom,'');
     else	
       fieldStateChangeWr (txtCustom,'','','');
   }
function setConnectionSpeed ()
	{
	var selValue = comboSelectedValueGet ('selConType');
	var upSpeedObj = document.getElementById('upload');
	var downSpeedObj = document.getElementById('download');
	if (!selValue || !upSpeedObj || !downSpeedObj) return;
    switch (parseInt (selValue, 10))
    	{
        case 0:
        case 2:
        	upSpeedObj.selectedIndex = 6;
        	downSpeedObj.selectedIndex = 6;
        	break;
        case 1:
        	upSpeedObj.selectedIndex = 3;
        	downSpeedObj.selectedIndex = 6;
        	break;
        case 3:
        	upSpeedObj.selectedIndex = 7;
        	downSpeedObj.selectedIndex = 7;
        	break;
        case 4:
        	upSpeedObj.selectedIndex = 9;
        	downSpeedObj.selectedIndex = 9;
        	break;
        case 5:
        default:
        	upSpeedObj.selectedIndex = 0;
        	downSpeedObj.selectedIndex = 0;
    	}
       	fieldStateChangeWr ('txt1Custom txt2Custom','','','');
	}

function detectMethodCheck ()
	{
	var method = comboSelectedValueGet  ('seldetectType');
	if (!method ) return;
	switch (parseInt(method , 10))
		{
		case 0:		/* USE WAN DNS */
			fieldStateChangeWr ('','tblDnsServer tblIpAddr','txtFailover txtPeriod','');
			break;
		case 1:		/* Custom DNS */
			fieldStateChangeWr ('','tblIpAddr','txtFailover txtPeriod','tblDnsServer');
			break;
		case 2:		/* Ping */
			fieldStateChangeWr ('','tblDnsServer','txtFailover txtPeriod','tblIpAddr');
			break;
		case 3:		/* None */
		default:
			fieldStateChangeWr ('txtFailover txtPeriod','tblDnsServer tblIpAddr','','');
			break;
	
		}  
	}

function deleteOptions (selObj)
	{
	while(selObj.options.length != 0)
		selObj.options[0]=null;
	}

function checkFailOver ()
	{
	var autoRollOverObj = document.getElementById ('hdAutoRollOver');
	if (!autoRollOverObj) return;
	if (autoRollOverObj.value != "1") return;
	var primWanObj = document.getElementById ('hdPrimWanId');
	var wanIdObj = document.getElementById ('hdWanId');
	if (!primWanObj || !wanIdObj) return;
	if (primWanObj.value == wanIdObj.value)
		{
		var selObj = document.getElementById ('seldetectType');
		deleteOptions (selObj)
		selObj.options [0] = new Option("WAN DNS", "0", false, false);
		selObj.options [1] = new Option("Custom DNS", "1", false, false);
		selObj.options [2] = new Option("Ping", "2", false, false);
		optionValueSelect ('seldetectType', 'hdFailDetect');
		detectMethodCheck ();
		}
	}
